/* 
   Problema Festa Junina -- junina.c
   Seletiva IOI 2003 
   Guilherme Ottoni
   Algoritmo: backtracking para gerar todas as 2^n comissoes possiveis.
              complexidade: O(n * 2^n)
*/

#include <stdio.h>
#include <string.h>

#define MAX_ALUNOS 20

int grafo[MAX_ALUNOS][MAX_ALUNOS];
int comissao[MAX_ALUNOS];
int n, max_alunos;

void gera_comissoes(int i, int n_alunos)
{
  int j;
  if (i == n)
    {
      if (n_alunos > max_alunos)
	max_alunos = n_alunos;
      return;
    }
  /* se o nro de alunos que ainda podem entrar na comissao nao for suficiente 
     para conseguir uma comissao maior do que a melhor solucao ja encontrada, 
     entao retorne */
  if (n_alunos + n - i < max_alunos)
    return;
  /* verifica as restricoes de i com os alunos que estao na comissao atual */
  for (j = 0; j < i && !(grafo[i][j] && comissao[j]); j++);
  /* se o aluno i pode participar da comissao c/ os alunos que ja estao nela */
  if (j == i)
    {
      comissao[i] = 1;
      gera_comissoes(i + 1, n_alunos + 1);      
    }
  /* testa as possibilidades sem colocar i na comissao */
  comissao[i] = 0;
  gera_comissoes(i + 1, n_alunos);
}

int main()
{
  int i, j, teste=1;
  while (scanf("%d", &n) == 1 && n > 0)
    {
      memset(grafo, 0, sizeof(grafo));
      for (i = 0; i < n; i++)
	while (scanf("%d", &j) && j > 0)
	  {
	    j--;
	    grafo[i][j] = grafo[j][i] = 1;
	  }
      max_alunos = 0;
      gera_comissoes(0, 0);
      printf("Teste %d\n%d\n\n", teste++, max_alunos);
    }
  return 0;
}

